/* IBM_PROLOG_BEGIN_TAG                                                   */
/* This is an automatically generated prolog.                             */
/*                                                                        */
/*                                                                        */
/*                                                                        */
/* Licensed Materials - Property of IBM                                   */
/*                                                                        */
/* Restricted Materials of IBM                                            */
/*                                                                        */
/* (C) COPYRIGHT International Business Machines Corp. 2008,2012          */
/* All Rights Reserved                                                    */
/*                                                                        */
/* US Government Users Restricted Rights - Use, duplication or            */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.      */
/*                                                                        */
/* IBM_PROLOG_END_TAG                                                     */
#ifndef _MIO_USER_H
#define _MIO_USER_H

#ifndef _LARGE_FILES
#define _LARGE_FILES
#endif

#include <fcntl.h>
#include <stdio.h>
#include <errno.h>
#include <aio.h>

#ifndef MIO_STRUCT_AIOCB
#define MIO_STRUCT_AIOCB struct aiocb64
#define MIO_STRUCT_LIOCB struct liocb64
#endif

#ifdef __linux__
#define int64 long long
#endif

extern int MIO_open(char *, int, int, void *);

extern int MIO_open64(char *, int, int, void *);

extern int MIO_fstat64(int, struct stat64 *);

extern off_t MIO_lseek(int, off_t, int);

#if defined __AIX__ || (defined(__linux__) && defined(_LARGEFILE64_SOURCE))
extern off64_t MIO_lseek64(int, off64_t, int);
#endif

extern int MIO_ftruncate64(int, int64);

extern ssize_t MIO_read(int, void *, size_t);

extern ssize_t MIO_write(int, const void *, size_t);

extern int MIO_close(int);

extern int MIO_fcntl(int, int, int *);

extern int MIO_ffinfo(int, int, struct diocapbuf *, int);

extern int MIO_fsync(int);

extern int MIO_aio_read64(int, MIO_STRUCT_AIOCB *);

extern int MIO_aio_write64(int, MIO_STRUCT_AIOCB *);

extern int MIO_aio_suspend64(int, MIO_STRUCT_AIOCB **);

extern int MIO_aio_nwait64(int, int, MIO_STRUCT_AIOCB **);

extern int MIO_aio_cancel64(int, MIO_STRUCT_AIOCB *);

extern int MIO_lio_listio64(int, MIO_STRUCT_LIOCB **, int, void *);

#if defined(USE_MIO_DEFINES)

#ifdef open64
#undef open64
#endif
#define open64(a,b,c)        MIO_open64(a,b,c,0)

#ifdef fstat64
#undef fstat64
#endif
#define fstat64(a,b)         MIO_fstat64(a,b)

#if defined __AIX__ || (defined(__linux__) && defined(LARGEFILE64_SOURCE))
#ifdef lseek64
#undef lseek64
#endif
#define lseek64(a,b,c)       MIO_lseek64(a,b,c)
#endif

#ifdef ftruncate64
#undef ftruncate64
#endif
#define ftruncate64(a,b)     MIO_ftruncate64(a,b)

#ifdef read
#undef read
#endif
#define read(a,b,c)          MIO_read(a,b,c)

#ifdef write
#undef write
#endif
#define write(a,b,c)         MIO_write(a,b,c)

#ifdef close
#undef close
#endif
#define close(a)             MIO_close(a)

#ifdef fcntl
#undef fcntl
#endif
#define fcntl(a,b,c)         MIO_fcntl(a,b,c)

#ifdef ffinfo
#undef ffinfo
#endif
#define ffinfo(a,b,c,d)      MIO_ffinfo(a,b,c,d)

#ifdef fsync
#undef fsync
#endif
#define fsync(a)             MIO_fsync(a)

#ifdef aio_read64
#undef aio_read64
#endif
#define aio_read64(a,b)      MIO_aio_read64(a,b)

#ifdef aio_write64
#undef aio_write64
#endif
#define aio_write64(a,b)     MIO_aio_write64(a,b)

#ifdef aio_suspend64
#undef aio_suspend64
#endif
#define aio_suspend64(a,b)   MIO_aio_suspend64(a,b)

#ifdef aio_nwait
#undef aio_nwait
#endif
#define aio_nwait(a,b,c)     MIO_aio_nwait64(a,b,c)

#ifdef aio_cancel64
#undef aio_cancel64
#endif
#define aio_cancel64(a,b)    MIO_aio_cancel64(a,b)

#ifdef lio_listio64
#undef lio_listio64
#endif
#define lio_listio64(a,b,c,d) MIO_lio_listio64(a,b,c,d)

#endif

#endif /* _MIO_USER_H  */
